apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRole
metadata:
  name: manager-role
rules:
##
## Base operator rules
##
# We need to get namespaces so the operator can read namespaces to ensure they exist
- apiGroups:
  - ""
  resources:
  - namespaces
  verbs:
  - get
  - create
# We need to manage Helm release secrets
- apiGroups:
  - ""
  resources:
  - secrets
  verbs:
  - "*"
# We need to create events on CRs about things happening during reconciliation
- apiGroups:
  - ""
  resources:
  - events
  verbs:
  - create

##
## Rules for stackgres.io/v1, Kind: SGConfig
##
- apiGroups:
  - operators.coreos.com
  resources:
  - operators
  verbs:
  - get
  - list
- apiGroups:
  - stackgres.io
  resources:
  - sgconfigs
  - sgconfigs/status
  - sgconfigs/finalizers
  verbs:
  - create
  - delete
  - get
  - list
  - patch
  - update
  - watch
- verbs:
  - "*"
  apiGroups:
  - "rbac.authorization.k8s.io"
  resources:
  - "clusterrolebindings"
  - "clusterroles"
- verbs:
  - "*"
  apiGroups:
  - ""
  resources:
  - "configmaps"
  - "secrets"
  - "serviceaccounts"
  - "services"
- verbs:
  - "*"
  apiGroups:
  - "apps"
  resources:
  - "deployments"
- verbs:
  - "*"
  apiGroups:
  - "batch"
  resources:
  - "jobs"
- apiGroups:
  - certificates.k8s.io
  resources:
  - certificatesigningrequests
  verbs:
  - list
- apiGroups:
  - certificates.k8s.io
  resources:
  - certificatesigningrequests
  verbs:
  - create
  - get
  - list
  - watch
  - delete
  resourceNames:
  - stackgres-operator
- apiGroups:
  - certificates.k8s.io
  resources:
  - certificatesigningrequests/approval
  verbs:
  - update
- apiGroups:
  - certificates.k8s.io
  resourceNames:
  - stackgres-operator.stackgres/*
  resources:
  - signers
  verbs:
  - approve
- apiGroups:
  - admissionregistration.k8s.io
  resourceNames:
  - stackgres-operator
  resources:
  - mutatingwebhookconfigurations
  - validatingwebhookconfigurations
  verbs:
  - '*'
- apiGroups:
  - apiextensions.k8s.io
  resources:
  - customresourcedefinitions
  verbs:
  - list
- apiGroups:
  - apiextensions.k8s.io
  resourceNames:
  - sgbackupconfigs.stackgres.io
  - sgbackups.stackgres.io
  - sgclusters.stackgres.io
  - sgdbops.stackgres.io
  - sgdistributedlogs.stackgres.io
  - sginstanceprofiles.stackgres.io
  - sgobjectstorages.stackgres.io
  - sgpgconfigs.stackgres.io
  - sgpoolconfigs.stackgres.io
  - sgscripts.stackgres.io
  resources:
  - customresourcedefinitions
  verbs:
  - list
  - get
  - watch
  - create
  - patch
  - update
- apiGroups:
  - stackgres.io
  resources:
  - sgbackupconfigs
  - sgbackups
  - sgclusters
  - sgdbops
  - sgdistributedlogs
  - sginstanceprofiles
  - sgobjectstorages
  - sgpgconfigs
  - sgpoolconfigs
  - sgscripts
  verbs:
  - '*'

#+kubebuilder:scaffold:rules
